#ifndef SRC_FLATUSB_CONFIG
#define SRC_FLATUSB_CONFIG

#include <stm32f4xx_hal.h>

#define USB_VBUSSENSE (0)

static inline void usbdrv_gpio_init() {
    // turn on GPIO clocks
    __HAL_RCC_GPIOA_CLK_ENABLE();
    __HAL_RCC_GPIOB_CLK_ENABLE();
    __HAL_RCC_GPIOC_CLK_ENABLE();
    
    // initialize pins
    GPIO_InitTypeDef gpio_init;
    gpio_init.Mode = GPIO_MODE_AF_PP;
    gpio_init.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
    gpio_init.Pull = GPIO_NOPULL;
    gpio_init.Alternate = GPIO_AF10_OTG_HS;

    gpio_init.Pin = GPIO_PIN_3 | GPIO_PIN_5; // D0, CK
    HAL_GPIO_Init(GPIOA, &gpio_init);

    // D1, D2, D7, D3, D4, D5, D6
    gpio_init.Pin = GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_5 | GPIO_PIN_10 | GPIO_PIN_11 | GPIO_PIN_12 | GPIO_PIN_13;
    HAL_GPIO_Init(GPIOB, &gpio_init);

    // STP, DIR, NXT
    gpio_init.Pin = GPIO_PIN_0 | GPIO_PIN_2 | GPIO_PIN_3;
    HAL_GPIO_Init(GPIOC, &gpio_init);

#if USB_VBUSSENSE
    // FIXME
#endif
}

#define USB_IRQ_N OTG_HS_IRQn
#define USB_IRQ_HANDLER OTG_HS_IRQHandler
#define USB_IRQ_PRIORITY (8)
#define USB_IRQ_SET_PRIORITY(irq, priority) HAL_NVIC_SetPriority((irq),(priority),0)
#define USB_IRQ_ENABLE(irq) HAL_NVIC_EnableIRQ((irq))
#define USB_IRQ_DISABLE(irq) HAL_NVIC_DisableIRQ((irq))

#define USBG (USB_OTG_HS)

#define USB_CLOCK_ENABLE() __HAL_RCC_USB_OTG_HS_CLK_ENABLE(); __HAL_RCC_USB_OTG_HS_ULPI_CLK_ENABLE()

#define USB_INTERNAL (0)
#define USB_UPLI (1)

#include "embfmt/embformat.h"
#define SNPRINTF(str, n, fmt, ...) embfmt(str, n, fmt, __VA_ARGS__)

#ifdef USBDBGMSG
#define USBMSG(...) MSG(__VA_ARGS__)
#endif

#endif /* SRC_FLATUSB_CONFIG */
